#!/usr/bin/php -Cq
<?php
- require_once(dirname(dirname(__FILE__)).'/lib/init-cmd.php');
+ require_once(dirname(dirname(__FILE__)).'/settings/settings.php');
+ require_once(CONST_BasePath.'/lib/init-cmd.php');
ini_set('memory_limit', '800M');
$aCMDOptions = array(
array('index-output', '', 0, 1, 1, 1, 'string', 'File to dump index information to'),
array('create-search-indices', '', 0, 1, 0, 0, 'bool', 'Create additional indices required for search and update'),
array('create-website', '', 0, 1, 1, 1, 'realpath', 'Create symlinks to setup web directory'),
+ array('drop', '', 0, 1, 0, 0, 'bool', 'Drop tables needed for updates, making the database readonly (EXPERIMENTAL)'),
);
getCmdOpt($_SERVER['argv'], $aCMDOptions, $aCMDResult, true, true);
}
// Assume we can steal all the cache memory in the box (unless told otherwise)
- $iCacheMemory = (isset($aCMDResult['osm2pgsql-cache'])?$aCMDResult['osm2pgsql-cache']:getCacheMemoryMB());
- if ($iCacheMemory > getTotalMemoryMB())
+ if (isset($aCMDResult['osm2pgsql-cache']))
+ {
+ $iCacheMemory = $aCMDResult['osm2pgsql-cache'];
+ }
+ else
{
$iCacheMemory = getCacheMemoryMB();
- echo "WARNING: resetting cache memory to $iCacheMemory\n";
}
$aDSNInfo = DB::parseDSN(CONST_Database_DSN);
pgsqlRunScriptFile(CONST_Path_Postgresql_Postgis.'/postgis.sql');
pgsqlRunScriptFile(CONST_Path_Postgresql_Postgis.'/spatial_ref_sys.sql');
} else {
- pgsqlRunScript('CREATE EXTENSION postgis');
+ pgsqlRunScript('CREATE EXTENSION IF NOT EXISTS postgis');
}
if ($fPostgisVersion < 2.1) {
// Function was renamed in 2.1 and throws an annoying deprecation warning
$osm2pgsql .= ' --tablespace-main-data '.CONST_Tablespace_Place_Data;
if (CONST_Tablespace_Place_Index)
$osm2pgsql .= ' --tablespace-main-index '.CONST_Tablespace_Place_Index;
- $osm2pgsql .= ' -lsc -O gazetteer --hstore';
+ $osm2pgsql .= ' -lsc -O gazetteer --hstore --number-processes 1';
$osm2pgsql .= ' -C '.$iCacheMemory;
$osm2pgsql .= ' -P '.$aDSNInfo['port'];
$osm2pgsql .= ' -d '.$aDSNInfo['database'].' '.$aCMDResult['osm-file'];
{
echo "Functions\n";
$bDidSomething = true;
- if (!file_exists(CONST_BasePath.'/module/nominatim.so')) fail("nominatim module not built");
+ if (!file_exists(CONST_InstallPath.'/module/nominatim.so')) fail("nominatim module not built");
$sTemplate = file_get_contents(CONST_BasePath.'/sql/functions.sql');
- $sTemplate = str_replace('{modulepath}', CONST_BasePath.'/module', $sTemplate);
+ $sTemplate = str_replace('{modulepath}', CONST_InstallPath.'/module', $sTemplate);
if ($aCMDResult['enable-diff-updates']) $sTemplate = str_replace('RETURN NEW; -- @DIFFUPDATES@', '--', $sTemplate);
if ($aCMDResult['enable-debug-statements']) $sTemplate = str_replace('--DEBUG:', '', $sTemplate);
if (CONST_Limit_Reindexing) $sTemplate = str_replace('--LIMIT INDEXING:', '', $sTemplate);
echo "Functions\n";
$sTemplate = file_get_contents(CONST_BasePath.'/sql/functions.sql');
$sTemplate = str_replace('{modulepath}',
- CONST_BasePath.'/module', $sTemplate);
+ CONST_InstallPath.'/module', $sTemplate);
pgsqlRunScript($sTemplate);
}
if (!pg_query($oDB->connection, $sSQL)) fail(pg_last_error($oDB->connection));
}
- if ($aCMDResult['osmosis-init'] || $aCMDResult['all'])
+ if ($aCMDResult['osmosis-init'] || ($aCMDResult['all'] && !$aCMDResult['drop'])) // no use doing osmosis-init when dropping update tables
{
$bDidSomething = true;
$oDB =& getDB();
}
else
{
- if (file_exists(CONST_BasePath.'/settings/configuration.txt'))
+ if (file_exists(CONST_InstallPath.'/settings/configuration.txt'))
{
echo "settings/configuration.txt already exists\n";
}
else
{
- passthru(CONST_Osmosis_Binary.' --read-replication-interval-init '.CONST_BasePath.'/settings');
+ passthru(CONST_Osmosis_Binary.' --read-replication-interval-init '.CONST_InstallPath.'/settings');
// update osmosis configuration.txt with our settings
- passthru("sed -i 's!baseUrl=.*!baseUrl=".CONST_Replication_Url."!' ".CONST_BasePath.'/settings/configuration.txt');
- passthru("sed -i 's:maxInterval = .*:maxInterval = ".CONST_Replication_MaxInterval.":' ".CONST_BasePath.'/settings/configuration.txt');
+ passthru("sed -i 's!baseUrl=.*!baseUrl=".CONST_Replication_Url."!' ".CONST_InstallPath.'/settings/configuration.txt');
+ passthru("sed -i 's:maxInterval = .*:maxInterval = ".CONST_Replication_MaxInterval.":' ".CONST_InstallPath.'/settings/configuration.txt');
}
// Find the last node in the DB
echo "Getting state file: $sRepURL\n";
$sStateFile = file_get_contents($sRepURL);
if (!$sStateFile || strlen($sStateFile) > 1000) fail("unable to obtain state file");
- file_put_contents(CONST_BasePath.'/settings/state.txt', $sStateFile);
+ file_put_contents(CONST_InstallPath.'/settings/state.txt', $sStateFile);
echo "Updating DB status\n";
pg_query($oDB->connection, 'TRUNCATE import_status');
$sSQL = "INSERT INTO import_status VALUES('".$aRepMatch[2]."')";
$bDidSomething = true;
$sOutputFile = '';
if (isset($aCMDResult['index-output'])) $sOutputFile = ' -F '.$aCMDResult['index-output'];
- $sBaseCmd = CONST_BasePath.'/nominatim/nominatim -i -d '.$aDSNInfo['database'].' -P '.$aDSNInfo['port'].' -t '.$iInstances.$sOutputFile;
+ $sBaseCmd = CONST_InstallPath.'/nominatim/nominatim -i -d '.$aDSNInfo['database'].' -P '.$aDSNInfo['port'].' -t '.$iInstances.$sOutputFile;
passthruCheckReturn($sBaseCmd.' -R 4');
if (!$aCMDResult['index-noanalyse']) pgsqlRunScript('ANALYSE');
passthruCheckReturn($sBaseCmd.' -r 5 -R 25');
fail("Target directory does not exist.");
}
- @symlink(CONST_BasePath.'/website/details.php', $sTargetDir.'/details.php');
- @symlink(CONST_BasePath.'/website/reverse.php', $sTargetDir.'/reverse.php');
- @symlink(CONST_BasePath.'/website/search.php', $sTargetDir.'/search.php');
- @symlink(CONST_BasePath.'/website/search.php', $sTargetDir.'/index.php');
- @symlink(CONST_BasePath.'/website/lookup.php', $sTargetDir.'/lookup.php');
- @symlink(CONST_BasePath.'/website/deletable.php', $sTargetDir.'/deletable.php');
- @symlink(CONST_BasePath.'/website/polygons.php', $sTargetDir.'/polygons.php');
- @symlink(CONST_BasePath.'/website/status.php', $sTargetDir.'/status.php');
+ @symlink(CONST_InstallPath.'/website/details.php', $sTargetDir.'/details.php');
+ @symlink(CONST_InstallPath.'/website/reverse.php', $sTargetDir.'/reverse.php');
+ @symlink(CONST_InstallPath.'/website/search.php', $sTargetDir.'/search.php');
+ @symlink(CONST_InstallPath.'/website/search.php', $sTargetDir.'/index.php');
+ @symlink(CONST_InstallPath.'/website/lookup.php', $sTargetDir.'/lookup.php');
+ @symlink(CONST_InstallPath.'/website/deletable.php', $sTargetDir.'/deletable.php');
+ @symlink(CONST_InstallPath.'/website/polygons.php', $sTargetDir.'/polygons.php');
+ @symlink(CONST_InstallPath.'/website/status.php', $sTargetDir.'/status.php');
@symlink(CONST_BasePath.'/website/images', $sTargetDir.'/images');
@symlink(CONST_BasePath.'/website/js', $sTargetDir.'/js');
@symlink(CONST_BasePath.'/website/css', $sTargetDir.'/css');
}
}
+ if ($aCMDResult['drop'])
+ {
+ // The implementation is potentially a bit dangerous because it uses
+ // a positive selection of tables to keep, and deletes everything else.
+ // Including any tables that the unsuspecting user might have manually
+ // created. USE AT YOUR OWN PERIL.
+ $bDidSomething = true;
+
+ // tables we want to keep. everything else goes.
+ $aKeepTables = array(
+ "*columns",
+ "import_polygon_*",
+ "import_status",
+ "place_addressline",
+ "location_property*",
+ "placex",
+ "search_name",
+ "seq_*",
+ "word",
+ "query_log",
+ "new_query_log",
+ "gb_postcode",
+ "spatial_ref_sys",
+ "country_name",
+ "place_classtype_*"
+ );
+
+ $oDB =& getDB();
+ $aDropTables = array();
+ $aHaveTables = $oDB->getCol("SELECT tablename FROM pg_tables WHERE schemaname='public'");
+ if (PEAR::isError($aHaveTables))
+ {
+ fail($aPartitions->getMessage());
+ }
+ foreach($aHaveTables as $sTable)
+ {
+ $bFound = false;
+ foreach ($aKeepTables as $sKeep)
+ {
+ if (fnmatch($sKeep, $sTable))
+ {
+ $bFound = true;
+ break;
+ }
+ }
+ if (!$bFound) array_push($aDropTables, $sTable);
+ }
+
+ foreach ($aDropTables as $sDrop)
+ {
+ if ($aCMDResult['verbose']) echo "dropping table $sDrop\n";
+ @pg_query($oDB->connection, "DROP TABLE $sDrop CASCADE");
+ // ignore warnings/errors as they might be caused by a table having
+ // been deleted already by CASCADE
+ }
+
+ if (!is_null(CONST_Osm2pgsql_Flatnode_File))
+ {
+ if ($aCMDResult['verbose']) echo "deleting ".CONST_Osm2pgsql_Flatnode_File."\n";
+ unlink(CONST_Osm2pgsql_Flatnode_File);
+ }
+ }
+
if (!$bDidSomething)
{
showUsage($aCMDOptions, true);